#pragma once

#include "VisualStyle.h"
#include "Preference.h"
#include "Status.h"

using namespace Gdiplus;
using namespace ATL;

class CVolumeBar:
    public CWindowImpl<CVolumeBar>
{
public:
	CVolumeBar(void);
	virtual ~CVolumeBar(void);

    BOOL Create(
        HWND hwndParent,
        const CPreference* pPrefs,
		CStatus *pStat);

BEGIN_MSG_MAP(CVolumeBar)
    MESSAGE_HANDLER(WM_PAINT, OnPaint)
    MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
    MESSAGE_HANDLER(WM_THEMECHANGED, OnThemeChanged)
    MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBackground)
	MESSAGE_HANDLER(WM_LBUTTONDBLCLK, OnLButtonDblClk)
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
	MESSAGE_HANDLER(WM_MOUSEWHEEL , OnMouseWheel)

END_MSG_MAP()

    LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnThemeChanged(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnEraseBackground(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnLButtonDblClk(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMouseWheel(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	void Paint(HDC hdc, const RECT& rcPaint) const;

private:
	void CreateRoundedRectangle(GraphicsPath &path , RectF rect, SizeF size) const;
	void DrawBar( HDC hdc,RectF rect, SizeF round )const;
	

private:
	const CPreference* m_pPrefs;
	CStatus*	m_pStat;

    CAutoPtr<CVisualStyle> m_ptrVisualStyle;

	ULONG_PTR           mGdiToken;

	CWindow	m_hwndParent;
	bool m_1stclick;
};

