#pragma once

#include "Preference.h"
#include "PageAbout.h"
#include "PageColor.h"
#include "PageControl.h"
#include "PageAppearance.h"

using namespace WTL;

class CVolumeSettings: 
	public CPropertySheetImpl<CVolumeSettings>
{
public:
    CVolumeSettings(ATL::_U_STRINGorID title = (LPCTSTR)NULL,
        UINT uStartPage = 0, HWND hWndParent = NULL)
        : CPropertySheetImpl<CVolumeSettings>(title, uStartPage, hWndParent)
    {
        m_psh.dwFlags |= PSH_NOAPPLYNOW;

		AddPage( m_PageColor );
		AddPage( m_PageAppearance );
		AddPage( m_PageControl );
		AddPage( m_PageAbout );
    }
	virtual ~CVolumeSettings(void)
	{}

    BEGIN_MSG_MAP_EX(CVolumeSettings)
        CHAIN_MSG_MAP(CPropertySheetImpl<CVolumeSettings>)
    END_MSG_MAP()

	void	SetPreference( ){
		m_PageAbout.m_pPrefs = &m_preference ;
		m_PageColor.m_pPrefs = &m_preference ;
		m_PageControl.m_pPrefs = &m_preference ;
		m_PageAppearance.m_pPrefs = &m_preference ;
	}

public:
	CPreference		m_preference;
	CPageAbout		m_PageAbout;
	CPageColor		m_PageColor;
	CPageControl	m_PageControl;
	CPageAppearance	m_PageAppearance;

};
