#include "StdAfx.h"
#include "VolumeWindow.h"
#include "VisualStyle.h"
#include "Utils.h"


////////////////////////////////////////////////////////////////////////////////
// CVolumeWindow
CVolumeWindow::CVolumeWindow() :
    m_pDeskBand(NULL),
    m_fHasFocus(FALSE)
{

}

CVolumeWindow::~CVolumeWindow()
{
}

////////////////////////////////////////////////////////////////////////////////
// 

BOOL CVolumeWindow::Create(
    HWND hwndParent,
    LPUNKNOWN pDeskBand,
    LPUNKNOWN pInputObjectSite,
	const   CPreference* pPrefs,
	CStatus	*pStat)
{
    if(!__super::Create(hwndParent))
        return FALSE;

	if ( !m_wndVolumeBar.Create( m_hWnd , pPrefs , pStat ) ){
		return FALSE;
	}

    ATLASSERT(pDeskBand);
    m_pDeskBand = pDeskBand;

    ATLASSERT(pInputObjectSite);
    m_spInputObjectSite = pInputObjectSite;

    ATLASSERT(pPrefs);
    m_pPrefs = pPrefs;

    ATLASSERT(pStat);
    m_pStat= pStat;

//    UpdateCaption();

	// c[`bvRg[쐬
    m_tooltip.Create(m_hWnd,0,0,TTS_ALWAYSTIP );
    m_tooltip.Activate(TRUE);

    // GfBbgRg[̃c[`bvc[`bvRg[ɒǉ
    CToolInfo ti(TTF_SUBCLASS, m_wndVolumeBar);
    m_tooltip.AddTool(ti);

	m_pStat->SetTooltip( m_tooltip.m_hWnd );

    return TRUE;
}

POINTL CVolumeWindow::CalcMinimalSize() const
{
    POINTL pt = {
        ::GetSystemMetrics(SM_CXMIN),
        ::GetSystemMetrics(SM_CYMIN)
    };

    return pt;
}

POINTL CVolumeWindow::CalcIdealSize() const
{
    if(!IsWindow()) return CalcMinimalSize();

	// ^XNo[c̎́AX,ŸӖt]悤Ȃ̂ŁAwork around
	if ( !m_pStat->GetVertical() ){
		const POINTL pt = { m_pPrefs->m_MinLength , m_pPrefs->m_Height };
	    return pt;
	}else{
		const POINTL pt = { m_pPrefs->m_Height , m_pPrefs->m_MinLength };
	    return pt;
	}

}

BOOL CVolumeWindow::HasFocus() const
{
    return m_fHasFocus;
}

void CVolumeWindow::UpdateCaption()
{
    ATLASSERT(IsWindow());
    //m_sDateString = m_pDateFormat->FormatDateString(m_stLocalTime);
    Invalidate();
	m_wndVolumeBar.Invalidate();
}

////////////////////////////////////////////////////////////////////////////////
// Message handlers

LRESULT CVolumeWindow::OnFocus(
    UINT uMsg,
    WPARAM /*wParam*/,
    LPARAM /*lParam*/,
    BOOL& /*bHandled*/)
{
    m_fHasFocus = (uMsg == WM_SETFOCUS);

    if(m_spInputObjectSite)
        m_spInputObjectSite->OnFocusChangeIS(m_pDeskBand, m_fHasFocus);

    return 0L;
}

LRESULT CVolumeWindow::OnDestroy(
    UINT /*uMsg*/,
    WPARAM /*wParam*/,
    LPARAM /*lParam*/,
    BOOL& /*bHandled*/)
{
    //KillTimer(UPDATE_TIMER_ID);

    return 0;
}

LRESULT CVolumeWindow::OnEraseBackground(
    UINT /*uMsg*/,
    WPARAM /*wParam*/,
    LPARAM /*lParam*/,
    BOOL& /*bHandled*/)
{
    return 1;
}

//LRESULT CVolumeWindow::OnPaint(
//    UINT /*uMsg*/,
//    WPARAM /*wParam*/,
//    LPARAM /*lParam*/,
//    BOOL& /*bHandled*/)
//{
//    DoubleBufferPaint dbuffPaint(m_hWnd);
//    
//    Paint(dbuffPaint.GetDC(), dbuffPaint.GetPaintRect());
//
//    return 0;
//}

LRESULT CVolumeWindow::OnPowerBroadcast(
    UINT /*uMsg*/,
    WPARAM wParam,
    LPARAM /*lParam*/,
    BOOL& /*bHandled*/)
{
    if(wParam == PBT_APMRESUMECRITICAL ||
       wParam == PBT_APMRESUMESUSPEND ||
       wParam == PBT_APMRESUMESTANDBY)
    {
        // re-enable timer
        //ATLVERIFY(SetUpdateTimer() != 0);
    }

    return 0;
}

LRESULT CVolumeWindow::OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	RECT rc;
	GetClientRect( &rc );
	if ( m_wndVolumeBar.IsWindow() ){
		
		m_wndVolumeBar.MoveWindow( &rc ,TRUE );
	}
	return 0;
}

//LRESULT CVolumeWindow::OnTimer(
//    UINT /*uMsg*/,
//    WPARAM /*wParam*/,
//    LPARAM /*lParam*/,
//    BOOL& /*bHandled*/)
//{
//    SYSTEMTIME stNow = { 0 };
//    ::GetLocalTime(&stNow);
//
//    if(stNow.wDay != m_stLocalTime.wDay)
//    {
//        m_stLocalTime = stNow;
//        UpdateCaption();
//    }
//
//    return 0;
//}
//
//LRESULT CVolumeWindow::OnTimeChange(
//    UINT uMsg,
//    WPARAM wParam,
//    LPARAM lParam,
//    BOOL& bHandled)
//{
//    return OnTimer(uMsg, wParam, lParam, bHandled);
//}

//LRESULT CVolumeWindow::OnThemeChanged(
//    UINT /*uMsg*/,
//    WPARAM /*wParam*/,
//    LPARAM /*lParam*/,
//    BOOL& /*bHandled*/)
//{
//    // re-create theme style
//    m_ptrVisualStyle.Free();
//    m_ptrVisualStyle.Attach(CVisualStyle::Create());
//
//    return 0;
//}

//void CVolumeWindow::Paint(HDC hdc, const RECT& rcPaint) const
//{
//    m_ptrVisualStyle->DrawBackground(m_hWnd, hdc, rcPaint);
//
//	
//
//    RECT rcClient = { 0 };
//    GetClientRect(&rcClient);
//
//	Graphics grp(hdc);
//	const int wmergin = 2;
//	const int topmergin = 2;
//
//	int VCenter = (rcClient.bottom+(rcClient.top+topmergin))/2;
//
//
//	RectF rect( 
//		(REAL)(rcClient.left+wmergin) , 
//		(REAL)(VCenter - m_pPrefs->m_Height/2 ) , 
//		(REAL)(rcClient.right-rcClient.left-wmergin*2),
//		(REAL)( m_pPrefs->m_Height )
//		);
//	
//	SizeF sz( 8,8 );
//
//	GradietionBar vb( hdc , rect , sz , (REAL)m_pPrefs->m_Frame , 
//		m_pPrefs->m_Color1 , m_pPrefs->m_Color2 ,m_pPrefs->m_ColorBG ,m_pPrefs->m_ColorFrame1 , m_pPrefs->m_ColorFrame2 );
//	
//	vb.Draw( 80 ,  true );
//
//}
//
//UINT_PTR CVolumeWindow::SetUpdateTimer()
//{
//    // Wake up every 10 seconds.
//    UINT_PTR nTimerId = SetTimer(UPDATE_TIMER_ID, 10 * 1000);
//
//    ATLASSERT(nTimerId != 0);
//
//    return nTimerId;
//}

////////////////////////////////////////////////////////////////////////////////


LRESULT CVolumeWindow::OnTooltipGetDispInfo(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/)
{
    LPNMTTDISPINFO pntdi = (LPNMTTDISPINFO)pnmh;

	if( m_pPrefs->m_Popup && (pntdi->uFlags & TTF_IDISHWND) ){
        TCHAR	buff[ 256 ];
		if ( m_pStat->GetMute() ){
			_stprintf( buff , _T("%d%% (Mute)") , m_pStat->GetVolume() );
		}else{
			_stprintf( buff , _T("%d%%") , m_pStat->GetVolume() );
		}
        _tcscpy(pntdi->szText, buff);
    }

    return 0;

}
