// VDSetup.h : Declaration of the CVDSetup

#pragma once

#include "VDSetup.h"

using namespace ATL;

////////////////////////////////////////////////////////////////////////////////
// CVDSetup

class CVDSetup : 
	public CDialogImpl<CVDSetup>
{
public:
	CVDSetup();
	~CVDSetup();

	enum { IDD = IDD_VDSETUP };

BEGIN_MSG_MAP(CVDSetup)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnClickedOK)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnClickedCancel)
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnClickedOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

private:
    BOOL InitControls();
    BOOL InitControlHwnds();

private:
    CPath m_pathSettings;
    bool InitSettingsPath();
	void LoadSettings();
	bool SaveSettings() const;

private:	
	bool m_bDeskband;

private:	
	bool ApplyDeskbandProperties() const;
	bool DeskbandInstalled() const;
	CPath GetDeskbandModulePath() const;
	bool ExtractDeskbandBinary(const CPath& deskbandPath) const;
	bool DeleteDeskbandBinary(const CPath& deskbandPath) const;
	bool RegisterDeskband(const CPath& deskbandPath, bool bRegister) const;
	HRESULT RegisterDeskbandXP(const CPath& deskbandPath, bool bRegister) const;
	DWORD RegisterDeskbandSecure(CPath deskbandPath, bool bRegister) const;
	bool ShowDeskband() const;
	bool HideDeskband() const;

	CHyperLink m_link;     // nCp[N

};

////////////////////////////////////////////////////////////////////////////////